#!/usr/bin/perl

#
# This is a sample script for anyone writing
# thier own nmap log parser utilities
# using the same database format as nlog.
#

use DBI;

# grab our parameters from cmd line

$dbfile		= $ARGV[0];
$sqlname	= $ARGV[1];
$password 	= $ARGV[2];

if ($dbfile eq "" || $sqlname eq "" || $password eq "") {
        print "Usage: ./db2sql.pl <db file> <db name> <password>.\n";
        exit 1;
}


# create our database tables...

$sqlrec = $sqlname."_rec";
$sqlports = $sqlname."_ports";

$dbHandle = (DBI->connect('DBI:mysql:nlog','root',$password));

$sql = "CREATE TABLE $sqlrec ";
$sql .= " (address varchar(15) not NULL,";
$sql .= " portcount int NOT NULL,";
$sql .= " status int,";
$sql .= " seqindex int,";
$sql .= " os text,";
$sql .= " comment text )";

$dataObject = $dbHandle->prepare($sql);
$dataObject->execute();

$sql = "create table $sqlports (
	address varchar(15) not NULL,
	number int NOT NULL,
	state varchar(20) NOT NULL,
	proto varchar(5) NOT NULL,
	service varchar(255) )\;";

$dataObject = $dbHandle->prepare($sql);
$dataObject->execute();


# open our database and loop through it by line
open(NDB, $dbfile) || die "Can't open database: $!\n";

while (<NDB>){

chomp($_);

(@db_parse) = split(/\|/,$_);

$ch_ipaddress = $db_parse[0];
$ch_portnum = $db_parse[1];
$ch_ports = $db_parse[2];
$ch_status = $db_parse[3];
$ch_seqindex = $db_parse[4];
$ch_os = $db_parse[5];

if ($ch_status eq "Up") {
 $ch_status = 1;
}

$sql = "insert into $sqlrec values(
	\'$ch_ipaddress\',
	\'$ch_portnum\',
	\'$ch_status\',
	\'$ch_seqindex\',
	\"$ch_os\" )\;";

$dataObject = $dbHandle->prepare($sql);
$dataObject->execute();

@ch_ports = split(/,/,$ch_ports);


foreach $port (@ch_ports) {

	@ch_port = split(/\./,$port);
	$cp_num = $ch_port[0];
	$cp_state = $ch_port[1];
	$cp_proto = $ch_port[2];
	$cp_serv  = $ch_port[3];


	$sql = "insert into $sqlports values (
		\'$ch_ipaddress\',
		\'$cp_num\',
		\'$cp_state\',
		\'$cp_proto\',
		\'$cp_serv\')\;";

	$dataObject = $dbHandle->prepare($sql);
	$dataObject->execute();

}


}

close NDB;

$dbHandle->disconnect();

exit 0; 
