#!/usr/bin/perl

# read our configuration file
#use FindBin qw($Bin);
#require "${Bin}/nlog-config.ph";

# -- Script Variables --

$DBFILE = shift;
$HTMLOUTPUT = shift;

if ($DBFILE eq '' || $HTMLOUTPUT eq '') {
 print "Usage: ./stats.pl <dbfile> <output>\n";
 exit 0;
}

make_report();
exit 0;


#
# Generate a report from a nlog database file
#

sub make_report {

# -- counter variables --

my %OSCOUNT;
%SVCOUNT=();

%OSCOUNT =(
	 "Windows" => 0,
	 "MacOS" => 0,
	 "Linux" => 0,
	 "Cisco" => 0,
	 "IBM" => 0,
	 "SunOS" => 0,
	 "Solaris" => 0,
	 "OpenVMS" => 0,
	 "Novell" => 0,
	 "HP-UX" => 0,
	 "Xylogics" => 0,
	 "LaserJet" => 0,
	 "OSF1" => 0,
	 "AIX" => 0,
	 "IRIX" => 0,
	 "ComOS" => 0,
	 "Printer" => 0,
	 "Unknown" => 0);

$HOSTCOUNT = 0;

# -- open our html output file --

open(REPORT, ">>$HTMLOUTPUT") || die "Can't write to html: $!\n";

# -- html header --
print REPORT <<HEADER;
<html>
<head>
<style>
<!--
A:link          { text-decoration: none; }
A:active        { text-decoration: none; }
A:visited       { text-decoration: none; }
A:hover         { COLOR = #FFFF00 }
//-->
</style>
<html><head><title>Nmap Scan Statistics</title></head>
<body BGCOLOR="#000000" TEXT="#FFFFFF" LINK="#CCCCFF" ALINK="#FF0000" VLINK="#FF000C">

HEADER
# -- end html header --


# open our database and loop through it by line
print("Trying to open database at \'$DBFILE\'\n");
open(NDB, "<$DBFILE") || die "Could not open database.";


while (<NDB>){

$HOSTCOUNT++;

(@db_parse) = split(/\|/,$_);

$ch_ipaddress = $db_parse[0];
$ch_portnum = $db_parse[1];
$ch_ports = $db_parse[2];
$ch_status = $db_parse[3];
$ch_seqindex = $db_parse[4];
$ch_os = $db_parse[5];

@ch_ports = split(/,/,$ch_ports);


# -- start os stats --


$OS_FLAG = 0;
foreach $key (keys(%OSCOUNT)) {
    @chk_os = grep(/$key/,$ch_os);
    if ( $#chk_os >= 0 && $OS_FLAG == 0) {
     $OSCOUNT{$key}++;
     $OS_FLAG = 1;
    }
} 

if ($OS_FLAG eq 0) { $OSCOUNT{"Unknown"}++; }

# -- end OS stats --


foreach $port (@ch_ports) {

	@ch_port = split(/\./,$port);
	$cp_num = $ch_port[0];
	$cp_state = $ch_port[1];
	$cp_proto = $ch_port[2];
	$cp_serv  = $ch_port[3];

# all data for each host has been put in a variable
###################################################

#only if port is state: open
if ($cp_state eq "open") 
{
 if ($SVCOUNT{$cp_num} eq '') {
  $SVCOUNT{$cp_num} = 1;
 } else {
  $SVCOUNT{$cp_num}++;
 }
}

###################################################

}


}

close NDB;

print REPORT <<OSHEADER;

<hr size="1" color="#808080">
<font face="Verdana" color="#FFFFFF"><small>
<strong>Operating System Statistics</strong></small></font>
<hr size="1" color="#808080"><br><br>

OSHEADER

# -- end html header --

print REPORT "<pre>\n";
print REPORT "Total Host Scanned: $HOSTCOUNT\n\n";

foreach $key (keys(%OSCOUNT)) {
 if ($OSCOUNT{$key} != 0)
 {
   print REPORT "$key:\t $OSCOUNT{$key}\n";
 }
}

foreach $key (keys(%SVCOUNT)) {
 if ($SVCOUNT{$key} != 0)
 {
   print REPORT "$key:\t $SVCOUNT{$key}\n";
 }
}

print REPORT "</pre>\n";

# close our html and the report file handle

print REPORT "\n</body></html>";
close(REPORT);

}


sub lines { local *FILE, $.; open(FILE, shift) || return undef; 1 while(<FILE>); return $. }

sub counthosts {

($FILE) = @_;
 my $COUNT = 0;
 open(FDB, "<$FILE") || print REPORT "<H2>COULD NOT OPEN DATABASE!</H2>";
 while (<FDB>){
  $COUNT++;
  print "COUNT = $COUNT\n";
 }
 close(FDB);
 return $COUNT;
}

