#!/usr/bin/perl

#
# This is a sample script for anyone writing
# thier own nmap log parser utilities
# using the same database format as nlog.
#

# grab our parameters from cmd line

$dbfile = $ARGV[0];

if ($dbfile eq "" ) {
        print "error: please specify a database to parse.\n";
        exit 1;
}


# open our database and loop through it by line
open(NDB, $dbfile) || die "Can't open database: $!\n";

while (<NDB>){

(@db_parse) = split(/\|/,$_);

$ch_ipaddress = $db_parse[0];
$ch_portnum = $db_parse[1];
$ch_ports = $db_parse[2];
$ch_status = $db_parse[3];
$ch_seqindex = $db_parse[4];
$ch_os = $db_parse[5];

@ch_ports = split(/,/,$ch_ports);

#print ("db_parse = @db_parse\nch_ports = @ch_ports\n");

foreach $port (@ch_ports) {

	@ch_port = split(/\./,$port);
	$cp_num = $ch_port[0];
	$cp_state = $ch_port[1];
	$cp_proto = $ch_port[2];
	$cp_serv  = $ch_port[3];

	if ($cp_serv eq "www") {
		$cp_serv = "http";
	}

	if ($cp_state eq "open") {
	print "<a href=\"$cp_serv://$ch_ipaddress\">$cp_serv://$ch_ipaddress</a><br>\n";
	}
}


}

close NDB;
exit 0; 
